#Wither Effect
scoreboard players reset @e[nbt=!{active_effects:[{id:"minecraft:wither"}]},scores={decay_id=0..}] decay_id

#Decay Blast
execute as @e[tag=wither_skull] at @s run function power:d/move_skull
execute as @e[tag=wither_skull] at @s run function power:d/move_skull

scoreboard players add @e[tag=wither_skull] decay_life 1

kill @e[tag=wither_skull,scores={decay_life=100..}]

#Siphon
execute as @a[tag=fix_max_hp] run attribute @s generic.max_health base set 20
tag @a remove fix_max_hp

execute as @e[tag=siphon_effect] at @s run particle soul_fire_flame ~ ~ ~ 0 0 0 .01 2
execute as @e[tag=siphon_effect] at @s as @a if score @s id = @e[tag=siphon_effect,sort=nearest,limit=1] id facing entity @s eyes run tp @e[tag=siphon_effect,sort=nearest,limit=1] ^ ^ ^.5
execute as @e[tag=siphon_effect] at @s as @a if score @s id = @e[tag=siphon_effect,sort=nearest,limit=1] id if entity @s[distance=..2] run kill @e[tag=siphon_effect,sort=nearest,limit=1]

scoreboard players add @e[tag=siphon_effect] decay_life 1
kill @e[tag=siphon_effect,scores={decay_life=200..}]

#Remnants
scoreboard players add @e[tag=remnant_spawn] decay_life 1
execute as @e[tag=remnant_spawn,scores={decay_life=-29}] at @s run playsound entity.allay.death player @a ~ ~ ~ 4 .5
execute as @e[tag=remnant_spawn,scores={decay_life=-29}] at @s run playsound entity.wither.death player @a ~ ~ ~ 1
execute as @e[tag=remnant_spawn,scores={decay_life=-29}] at @s run summon area_effect_cloud ~ ~4 ~ {Duration:30,Radius:.5f,RadiusPerTick:.05f,Particle:{type:"smoke"}}
execute as @e[tag=remnant_spawn,scores={decay_life=-29}] at @s run summon area_effect_cloud ~ ~4 ~ {Duration:30,Radius:.5f,RadiusPerTick:.05f,Particle:{type:"smoke"}}
execute as @e[tag=remnant_spawn,scores={decay_life=-30..0}] at @s run tp @s ~ ~.135 ~
execute as @e[tag=remnant_spawn,scores={decay_life=-30..0}] at @s run particle smoke ~ ~1 ~ .2 .4 .2 0 20
execute as @e[tag=remnant_spawn,scores={decay_life=0}] run data merge entity @s {NoAI:false,Invulnerable:false}
execute as @e[tag=remnant_spawn,scores={decay_life=0}] run tag @s add remnant
execute as @e[tag=remnant_spawn,scores={decay_life=0}] run tag @s remove remnant_spawn

scoreboard players add @e[tag=remnant] decay_life 1
execute as @e[tag=remnant,scores={decay_life=400}] run data merge entity @s {NoAI:true,Invulnerable:true,Silent:true,DeathLootTable:""}
execute as @e[tag=remnant,scores={decay_life=400}] at @s run playsound entity.breeze.idle_ground player @a ~ ~ ~ 2 .8
execute as @e[tag=remnant,scores={decay_life=400}] at @s run summon area_effect_cloud ~ ~ ~ {Duration:15,Radius:.5f,RadiusPerTick:.05f,Particle:{type:"smoke"}}
execute as @e[tag=remnant,scores={decay_life=400}] at @s run summon area_effect_cloud ~ ~ ~ {Duration:15,Radius:.5f,RadiusPerTick:.05f,Particle:{type:"smoke"}}
execute as @e[tag=remnant,scores={decay_life=400..}] at @s run tp @s ~ ~-.2 ~

kill @e[tag=remnant,scores={decay_life=415..}]

execute as @a at @s as @e[tag=remnant] if score @s id = @p id run tag @p add keep_team
execute as @a at @s as @e[tag=remnant_spawn] if score @s id = @p id run tag @p add keep_team
execute as @a[scores={power=4},tag=!keep_team] at @s as @e[scores={decay_target=0..}] if score @s decay_target = @p id run scoreboard players reset @s decay_target
team leave @a[tag=!keep_team]
tag @a remove keep_team

execute as @e[tag=remnant,tag=!aggro] at @s as @e[nbt={HurtTime:0s},distance=..20] if score @s decay_id = @e[tag=remnant,sort=nearest,limit=1] id run function power:d/remnant_aggro

execute as @e[tag=remnant,tag=aggro] at @s as @e[scores={decay_target=0..}] if score @s decay_target = @e[tag=remnant,sort=nearest,limit=1] id run tag @e[tag=remnant,sort=nearest,limit=1] add keep_aggro
tag @e[tag=remnant,tag=!keep_aggro] remove aggro
tag @e remove keep_aggro

execute as @e[nbt={HurtTime:0s,active_effects:[{id:"minecraft:wither"}]}] at @s unless score @s decay_id matches 0.. if entity @e[tag=remnant,distance=..3] run scoreboard players operation @s decay_id = @e[tag=remnant,sort=nearest,limit=1] id
execute as @a[scores={decay_id=0..}] if score @s id = @s decay_id run scoreboard players reset @s decay_id

#Wither Armor
scoreboard players remove @a[scores={decay_armor=1..}] decay_armor 1

effect give @a[scores={decay_armor=1..}] resistance 1 2 true

execute as @a[scores={decay_armor=1..}] at @s run particle smoke ~ ~1 ~ .2 .4 .2 .01 2

execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor1] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor2] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor3] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor4] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor5] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor6] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor7] if score @s id = @p id run kill @s
execute as @a[scores={decay_armor=0}] at @s as @e[tag=wither_armor8] if score @s id = @p id run kill @s

scoreboard players reset @a[scores={decay_armor=0}] decay_armor

execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor1] if score @s id = @p id rotated ~ 0 run tp @s ^ ^.5 ^-.5 ~ ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor2] if score @s id = @p id rotated ~ 0 run tp @s ^-.5 ^.5 ^ ~-90 ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor3] if score @s id = @p id rotated ~ 0 run tp @s ^ ^.5 ^.5 ~180 ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor4] if score @s id = @p id rotated ~ 0 run tp @s ^.5 ^.5 ^ ~90 ~

execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor5] if score @s id = @p id rotated ~ 0 run tp @s ^ ^1.2 ^-.5 ~ ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor6] if score @s id = @p id rotated ~ 0 run tp @s ^-.5 ^1.2 ^ ~-90 ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor7] if score @s id = @p id rotated ~ 0 run tp @s ^ ^1.2 ^.5 ~180 ~
execute as @a[scores={decay_armor=1..}] at @s as @e[tag=wither_armor8] if score @s id = @p id rotated ~ 0 run tp @s ^.5 ^1.2 ^ ~90 ~

#Wither Seekers
execute unless entity @e[scores={seeker_id=0..}] run scoreboard players set num seeker_id 1

scoreboard players add @e[tag=wither_seeker] decay_life 1

execute as @e[tag=wither_seeker] at @s as @e[tag=!wither_seeker,scores={seeker_id=0..}] if score @s seeker_id = @e[tag=wither_seeker,sort=nearest,limit=1] seeker_id run function power:d/move_seeker

execute as @e[tag=wither_seeker,scores={decay_life=200..}] at @s as @e[tag=!wither_seeker,scores={seeker_id=0..}] if score @s seeker_id = @e[tag=wither_seeker,sort=nearest,limit=1] seeker_id run scoreboard players reset @s seeker_id
kill @e[tag=wither_seeker,scores={decay_life=200..}]

execute as @e[tag=wither_seeker,tag=!alive] at @s as @e[tag=!wither_seeker,scores={seeker_id=0..}] if score @s seeker_id = @e[tag=wither_seeker,sort=nearest,limit=1] seeker_id run scoreboard players reset @s seeker_id
kill @e[tag=wither_seeker,tag=!alive]

tag @e[tag=wither_seeker] remove alive

#Return to Dust
execute unless entity @e[scores={death_id=0..}] run scoreboard players set num death_id 1

scoreboard players add @a[scores={decay_ult=1..149}] decay_ult 1

execute as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] unless score @s decay_id matches 0.. run scoreboard players reset @s death_id

effect give @a[scores={decay_ult=149}] slow_falling 5 0 true
tag @a[scores={decay_ult=149}] remove attacking

execute as @a at @s as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total at @s as @e[tag=death] if score @s death_id = @e[tag=!death,tag=!death_pos,scores={death_id=0..},sort=nearest,limit=1] death_id run effect clear @s invisibility
execute as @a at @s as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp > @p decay_ult_total at @s as @e[tag=death] if score @s death_id = @e[tag=!death,tag=!death_pos,scores={death_id=0..},sort=nearest,limit=1] death_id run effect give @s invisibility infinite 0 true

execute as @a[scores={decay_ult=1..149}] at @s run particle smoke ~ ~1 ~ .4 .4 .4 .01 20

execute as @a[scores={decay_ult=1..150}] at @s as @e[scores={death_id=0..,death_hp=..6}] if score @s decay_id = @p id at @s run effect give @s resistance 1 255 true
execute as @a[scores={decay_ult=1..150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run particle smoke ~ ~ ~ .5 0 .5 .01 10

execute as @a[scores={decay_ult=130..150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run particle large_smoke ~ ~1 ~ .4 .6 .4 .05 30
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run playsound entity.wither.break_block player @a ~ ~ ~ 2
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run playsound entity.allay.death player @a ~ ~ ~ 4 .5
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run particle soul ~ ~1 ~ .2 .4 .2 .1 50
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run effect give @s blindness 1 0 true
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run effect clear @s resistance
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp > @p decay_ult_total run function power:d/rtd_dmg
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total at @s run effect give @s invisibility infinite 0 true

execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=player] at @s run summon wither_skeleton ~ ~ ~ {Tags:["death_effect","remnant"],NoAI:true,Invulnerable:true,DeathLootTable:""}
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=player] at @s run tp @e[tag=death_effect,sort=nearest,limit=1] ~ ~ ~ ~ ~

execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=#zombies,nbt=!{IsBaby:true}] at @s run summon wither_skeleton ~ ~ ~ {Tags:["death_effect","remnant"],NoAI:true,Invulnerable:true,DeathLootTable:""}
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=#zombies,nbt=!{IsBaby:true}] at @s run tp @e[tag=death_effect,sort=nearest,limit=1] ~ ~ ~ ~ ~

execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=#skeletons] at @s run summon wither_skeleton ~ ~ ~ {Tags:["death_effect","remnant"],NoAI:true,Invulnerable:true,DeathLootTable:""}
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total if entity @s[type=#skeletons] at @s run tp @e[tag=death_effect,sort=nearest,limit=1] ~ ~ ~ ~ ~

execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total at @s if entity @s[type=!player,type=!#zombies,type=!#skeletons] unless block ~ ~-1 ~ air run setblock ~ ~ ~ wither_rose keep
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id if score @s death_hp <= @p decay_ult_total run damage @s 200 wither by @p
execute as @a[scores={decay_ult=150}] at @s as @e[scores={death_id=0..}] if score @s decay_id = @p id at @s run scoreboard players reset @s death_id

execute as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] store result score @s death_hp run data get entity @s Health
execute as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] at @s as @e[tag=death_pos] if score @s death_id = @e[tag=!death,tag=!death_pos,scores={death_id=0..},sort=nearest,limit=1] death_id run tp @s ~ ~ ~
execute as @e[tag=death_pos] at @s as @e[tag=death] if score @s death_id = @e[tag=death_pos,sort=nearest,limit=1] death_id run tp @s ^ ^ ^3 ~180 20

execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s run particle smoke ~ ~1 ~ .2 .4 .2 0 50
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s rotated ~ 0 run particle smoke ^.6 ^1.4 ^ .1 .2 .1 0 10
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s rotated ~ 0 run particle smoke ^-.6 ^1.4 ^ .1 .2 .1 0 10
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s anchored eyes run particle smoke ^ ^ ^ .1 .2 .1 0 10
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s anchored eyes run particle smoke ^ ^ ^ .2 .2 .2 0 50
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s anchored eyes run particle electric_spark ^.15 ^ ^.5 0 0 0 0 1
execute as @e[tag=death,nbt=!{active_effects:[{id:"minecraft:invisibility"}]}] at @s anchored eyes run particle electric_spark ^-.15 ^ ^.5 0 0 0 0 1

execute as @e[tag=death] at @s as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] if score @s death_id = @e[tag=death,sort=nearest,limit=1] death_id run tag @e[tag=death,sort=nearest,limit=1] add alive
execute as @e[tag=death_pos] at @s as @e[tag=!death,tag=!death_pos,scores={death_id=0..}] if score @s death_id = @e[tag=death_pos,sort=nearest,limit=1] death_id run tag @e[tag=death_pos,sort=nearest,limit=1] add alive

effect give @e[tag=death,tag=!alive] invisibility infinite 0 true
kill @e[tag=death,tag=!alive]
kill @e[tag=death_pos,tag=!alive]

scoreboard players set @e[tag=death_effect,scores={decay_life=..300}] decay_life 350
execute as @e[tag=death_effect,scores={decay_life=399}] at @s align y unless block ~ ~-.5 ~ air run setblock ~ ~ ~ wither_rose keep

tag @e[tag=death] remove alive
tag @e[tag=death_pos] remove alive

execute if score ascend flame_timer matches 1 run effect give @a[scores={decay_ult=1..149}] levitation 1 0 true

#Passive
execute as @a[scores={power=4,kills=1..}] at @s run effect give @s instant_health 1 1 true
execute as @a[scores={power=4,kills=1..}] at @s run particle soul ~ ~1 ~ .2 .2 .2 .05 1
execute as @a[scores={power=4,kills=1..}] at @s run particle smoke ~ ~1 ~ .2 .4 .2 .01 100
execute as @a[scores={power=4,kills=1..}] at @s run playsound entity.allay.death player @a ~ ~ ~ 1 .5
scoreboard players reset @a kills

execute as @a unless score @s power matches 4 run scoreboard players reset @s dmg
scoreboard players reset @a[tag=disable,scores={power=4}] dmg