execute if score @s cd1 matches 0 run title @s[nbt={SelectedItemSlot:0},scores={mastery=1..}] actionbar {"text":"Fireball","color":"red","bold":true}
execute unless score @s mastery matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ""
execute if score @s cd1 matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ["",{"text":"Fireball: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd1_seconds"},"color":"gray","bold":true}]

execute if score @s cd2 matches 0 run title @s[nbt={SelectedItemSlot:1},scores={mastery=2..}] actionbar {"text":"Flame Meteor","color":"red","bold":true}
execute unless score @s mastery matches 2.. run title @s[nbt={SelectedItemSlot:1}] actionbar ""
execute if score @s cd2 matches 1.. run title @s[nbt={SelectedItemSlot:1}] actionbar ["",{"text":"Flame Meteor: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd2_seconds"},"color":"gray","bold":true}]

execute if score @s cd3 matches 0 run title @s[nbt={SelectedItemSlot:2},scores={mastery=3..}] actionbar {"text":"Smoke Ascension","color":"red","bold":true}
execute unless score @s mastery matches 3.. run title @s[nbt={SelectedItemSlot:2}] actionbar ""
execute if score @s cd3 matches 1.. run title @s[nbt={SelectedItemSlot:2}] actionbar ["",{"text":"Smoke Ascension: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd3_seconds"},"color":"gray","bold":true}]

execute if score @s cd4 matches 0 run title @s[nbt={SelectedItemSlot:3},scores={mastery=4..}] actionbar {"text":"Burning Wrath","color":"red","bold":true}
execute unless score @s mastery matches 4.. run title @s[nbt={SelectedItemSlot:3}] actionbar ""
execute if score @s cd4 matches 1.. run title @s[nbt={SelectedItemSlot:3}] actionbar ["",{"text":"Burning Wrath: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd4_seconds"},"color":"gray","bold":true}]

title @s[nbt=!{SelectedItemSlot:0},nbt=!{SelectedItemSlot:1},nbt=!{SelectedItemSlot:2},nbt=!{SelectedItemSlot:3},nbt=!{SelectedItemSlot:8}] actionbar ""

execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:0},scores={crouch=1..,cd1=0,mastery=1..}] unless score @s flame_awaken matches 0.. run function power:f/f1
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:1},scores={crouch=1..,cd2=0,mastery=2..}] unless score @s flame_awaken matches 0.. run function power:f/f2
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:0},scores={crouch=1..,cd1=0,mastery=1..}] if score @s flame_awaken matches 0.. run function power:f/awakened1
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:1},scores={crouch=1..,cd2=0,mastery=2..}] if score @s flame_awaken matches 0.. run function power:f/awakened2
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={crouch=1..,cd3=0,mastery=3..}] run function power:f/f3
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:3},scores={crouch=1..,cd4=0,mastery=4..}] run function power:f/f4

#Flame Meteor
execute as @e[tag=meteor,scores={fireball_life=20}] if score @s id = @p id as @p run function power:f/start_move_meteor

#Passive
effect give @s fire_resistance 1 0 true

scoreboard players add @s cook_timer 1
execute unless entity @s[nbt={SelectedItem:{id:"minecraft:potato"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:potato"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:beef"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:beef"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:porkchop"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:porkchop"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:mutton"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:mutton"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:chicken"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:chicken"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:rabbit"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:rabbit"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:cod"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:cod"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:salmon"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:salmon"}]}] unless entity @s[nbt={SelectedItem:{id:"minecraft:kelp"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:kelp"}]}] run scoreboard players reset @s cook_timer

execute if entity @s[nbt={SelectedItem:{id:"minecraft:potato"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:beef"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:porkchop"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:mutton"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:chicken"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:rabbit"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:cod"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:salmon"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={SelectedItem:{id:"minecraft:kelp"}}] anchored eyes run particle smoke ^-.3 ^-.5 ^.5 .1 .1 .1 .01 1

execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:potato"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:beef"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:porkchop"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:mutton"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:chicken"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:rabbit"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:cod"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:salmon"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1
execute if entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:kelp"}]}] anchored eyes run particle smoke ^.3 ^-.5 ^.5 .1 .1 .1 .01 1

execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:potato"}}] run give @s baked_potato
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:potato"}}] run clear @s potato 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:beef"}}] run give @s cooked_beef
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:beef"}}] run clear @s beef 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:porkchop"}}] run give @s cooked_porkchop
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:porkchop"}}] run clear @s porkchop 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:mutton"}}] run give @s cooked_mutton
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:mutton"}}] run clear @s mutton 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:chicken"}}] run give @s cooked_chicken
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:chicken"}}] run clear @s chicken 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:rabbit"}}] run give @s cooked_rabbit
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:rabbit"}}] run clear @s rabbit 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:cod"}}] run give @s cooked_cod
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:cod"}}] run clear @s cod 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:salmon"}}] run give @s cooked_salmon
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:salmon"}}] run clear @s salmon 1
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:kelp"}}] run give @s dried_kelp
execute if entity @s[scores={cook_timer=200..},nbt={SelectedItem:{id:"minecraft:kelp"}}] run clear @s kelp 1

execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:potato"}]}] run give @s baked_potato
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:potato"}]}] run clear @s potato 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:beef"}]}] run give @s cooked_beef
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:beef"}]}] run clear @s beef 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:porkchop"}]}] run give @s cooked_porkchop
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:porkchop"}]}] run clear @s porkchop 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:mutton"}]}] run give @s cooked_mutton
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:mutton"}]}] run clear @s mutton 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:chicken"}]}] run give @s cooked_chicken
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:chicken"}]}] run clear @s chicken 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:rabbit"}]}] run give @s cooked_rabbit
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:rabbit"}]}] run clear @s rabbit 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:cod"}]}] run give @s cooked_cod
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:cod"}]}] run clear @s cod 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:salmon"}]}] run give @s cooked_salmon
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:salmon"}]}] run clear @s salmon 1
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:kelp"}]}] run give @s dried_kelp
execute if entity @s[scores={cook_timer=200..},nbt={Inventory:[{Slot:-106b,id:"minecraft:kelp"}]}] run clear @s kelp 1

scoreboard players reset @s[scores={cook_timer=200..}] cook_timer