execute as @a unless score @s id matches 0.. run function power:set_id

scoreboard players reset @a[gamemode=spectator] crouch

scoreboard players add @e[nbt={OnGround:true},nbt=!{Invisible:true}] movedetectortime 1
execute as @e[scores={movedetectortime=2}] store result score @s xpos2 run scoreboard players get @s xpos
execute as @e[scores={movedetectortime=2}] store result score @s zpos2 run scoreboard players get @s zpos
execute as @e[nbt={OnGround:true},nbt=!{Invisible:true}] run execute store result score @s xpos run data get entity @s Pos[0] 1000000
execute as @e[nbt={OnGround:true},nbt=!{Invisible:true}] run execute store result score @s zpos run data get entity @s Pos[2] 1000000
scoreboard players set @e[scores={movedetectortime=2..}] movedetectortime 1
execute as @e[nbt={OnGround:true},nbt=!{Invisible:true}] run execute unless score @s xpos = @s xpos2 run scoreboard players set @s moved 1
execute as @e[nbt={OnGround:true},nbt=!{Invisible:true}] run execute unless score @s zpos = @s zpos2 run scoreboard players set @s moved 1

execute as @e[type=!marker] store result score @s true_xpos run data get entity @s Pos[0] 1
execute as @e[type=!marker] store result score @s true_zpos run data get entity @s Pos[2] 1

execute as @a unless score @s cd1 matches 0.. run scoreboard players set @s cd1 0
execute as @a unless score @s cd2 matches 0.. run scoreboard players set @s cd2 0
execute as @a unless score @s cd3 matches 0.. run scoreboard players set @s cd3 0
execute as @a unless score @s cd4 matches 0.. run scoreboard players set @s cd4 0
execute as @a unless score @s cd5 matches 0.. run scoreboard players set @s cd5 0

execute as @a if score @s cd1 matches 1.. run scoreboard players remove @s cd1 1
execute as @a if score @s cd2 matches 1.. run scoreboard players remove @s cd2 1
execute as @a if score @s cd3 matches 1.. run scoreboard players remove @s cd3 1
execute as @a if score @s cd4 matches 1.. run scoreboard players remove @s cd4 1
execute as @a if score @s cd5 matches 1.. run scoreboard players remove @s cd5 1

execute as @a run scoreboard players operation @s cd1_seconds = @s cd1
execute as @a run scoreboard players operation @s cd1_seconds /= num cd1_seconds
execute as @a run scoreboard players add @s cd1_seconds 1

execute as @a run scoreboard players operation @s cd2_seconds = @s cd2
execute as @a run scoreboard players operation @s cd2_seconds /= num cd2_seconds
execute as @a run scoreboard players add @s cd2_seconds 1

execute as @a run scoreboard players operation @s cd3_seconds = @s cd3
execute as @a run scoreboard players operation @s cd3_seconds /= num cd3_seconds
execute as @a run scoreboard players add @s cd3_seconds 1

execute as @a run scoreboard players operation @s cd4_seconds = @s cd4
execute as @a run scoreboard players operation @s cd4_seconds /= num cd4_seconds
execute as @a run scoreboard players add @s cd4_seconds 1

execute as @a run scoreboard players operation @s cd5_seconds = @s cd5
execute as @a run scoreboard players operation @s cd5_seconds /= num cd5_seconds
execute as @a run scoreboard players add @s cd5_seconds 1

title @a[scores={power=1..},nbt={SelectedItemSlot:8},tag=!disable] actionbar {"text":"Disable Power","bold":true}
title @a[scores={power=1..},nbt={SelectedItemSlot:8},tag=disable] actionbar {"text":"Enable Power","bold":true}

title @a[scores={power=1..},nbt=!{SelectedItemSlot:8},tag=disable] actionbar ""

tag @a[scores={power=1..,crouch=1..},nbt={SelectedItemSlot:8},tag=!attacking,tag=!disable] add startdisable
tag @a[scores={power=1..,crouch=1..},nbt={SelectedItemSlot:8},tag=!attacking,tag=disable] add startenable

execute as @a[tag=startdisable,nbt={SelectedItemSlot:8}] unless score @s crouch matches 1.. run tag @s add disable
execute as @a[tag=startdisable,nbt={SelectedItemSlot:8}] unless score @s crouch matches 1.. run tag @s remove startdisable

execute as @a[tag=startenable,nbt={SelectedItemSlot:8}] unless score @s crouch matches 1.. run tag @s remove disable
execute as @a[tag=startenable,nbt={SelectedItemSlot:8}] unless score @s crouch matches 1.. run tag @s remove startenable

tag @a[nbt=!{SelectedItemSlot:8}] remove startdisable
tag @a[nbt=!{SelectedItemSlot:8}] remove startenable

function power:c/tick
execute as @a[gamemode=!spectator,scores={power=1},tag=!disable] at @s run function power:c/abilities

function power:v/tick
execute as @a[gamemode=!spectator,scores={power=2},tag=!disable] at @s run function power:v/abilities

function power:f/tick
execute as @a[gamemode=!spectator,scores={power=3},tag=!disable] at @s run function power:f/abilities

function power:d/tick
execute as @a[gamemode=!spectator,scores={power=4},tag=!disable] at @s run function power:d/abilities

function power:o/tick
execute as @a[gamemode=!spectator,scores={power=5},tag=!disable] at @s run function power:o/abilities



function power:obelisk/tick

forceload remove all
execute in the_nether run forceload remove all
execute in the_end run forceload remove all
execute as @e[tag=gateway] at @s run forceload add ~ ~ ~ ~
execute as @e[tag=gateway_return] at @s run forceload add ~ ~ ~ ~
execute as @e[tag=gateway_charge] at @s run forceload add ~ ~ ~ ~
execute as @e[tag=obelisk_locater] at @s run forceload add ~-16 ~-16 ~16 ~16

scoreboard players reset @a used_item

execute as @e[scores={heardtime=1..}] run scoreboard players add @s heardtime 1
execute as @e[scores={heardtime=50..}] run scoreboard players reset @s heardtime
execute as @e[scores={moved=1}] at @s unless block ~ ~-1 ~ #wool unless block ~ ~ ~ #wool_carpets unless score @s heardtime matches 1.. unless score @s crouch matches 1.. run scoreboard players set @s heardtime 1
execute as @e[scores={moved=1}] run scoreboard players reset @s moved

execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:totem_of_undying",components:{"minecraft:custom_model_data":1}}]}] run tag @s add change_power
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:totem_of_undying",components:{"minecraft:custom_model_data":2}}]}] run tag @s add change_power
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:totem_of_undying",components:{"minecraft:custom_model_data":3}}]}] run tag @s add change_power
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:totem_of_undying",components:{"minecraft:custom_model_data":4}}]}] run tag @s add change_power
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:totem_of_undying",components:{"minecraft:custom_model_data":5}}]}] run tag @s add change_power

execute as @a[tag=change_power] if entity @s[gamemode=creative] run tag @s add creative
execute as @a[tag=change_power] if entity @s[gamemode=creative] run gamemode survival @s
execute as @a[tag=change_power] run damage @s 10000

tag @a remove change_power

execute as @a[tag=creative] run gamemode creative @s
execute as @a[tag=creative] run tag @s remove creative

tellraw @a[scores={menu=1}] ["-----Menu-----","\nClick one of the options below"]
tellraw @a[scores={menu=1}] {"text":"\n[Help]","color":"red","clickEvent": {"action":"run_command","value":"/trigger menu set 2"}}
tellraw @a[scores={menu=1}] {"text":"\n[Crafting]","color":"yellow","clickEvent": {"action":"run_command","value":"/trigger menu set 3"}}
tellraw @a[scores={menu=1}] {"text":"\n[Abilities]","color":"blue","clickEvent": {"action":"run_command","value":"/trigger menu set 4"}}

execute as @a[scores={menu=2}] run function power:menu/help
execute as @a[scores={menu=3}] run function power:menu/crafting
execute as @a[scores={menu=4}] run function power:menu/abilities
#execute as @a[scores={menu=5}] run function power:menu/unlock
#execute as @a[scores={menu=6}] run function power:menu/confirm_unlock

scoreboard players reset @a menu
scoreboard players enable @a menu

scoreboard players reset @a crouch