execute if score @s cd1 matches 0 run title @s[nbt={SelectedItemSlot:0},scores={mastery=1..}] actionbar {"text":"Teleport","color":"light_purple","bold":true}
execute unless score @s mastery matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ""
execute if score @s cd1 matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ["",{"text":"Teleport: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd1_seconds"},"color":"gray","bold":true}]

execute if score @s cd2 matches 0 run title @s[nbt={SelectedItemSlot:1},scores={mastery=2..}] actionbar {"text":"Void Walk","color":"light_purple","bold":true}
execute unless score @s mastery matches 2.. run title @s[nbt={SelectedItemSlot:1}] actionbar ""
execute if score @s cd2 matches 1.. run title @s[nbt={SelectedItemSlot:1}] actionbar ["",{"text":"Void Walk: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd2_seconds"},"color":"gray","bold":true}]

execute if score @s cd3 matches 0 run title @s[nbt={SelectedItemSlot:2},scores={mastery=3..}] actionbar {"text":"End Gateway","color":"light_purple","bold":true}
execute unless score @s mastery matches 3.. run title @s[nbt={SelectedItemSlot:2}] actionbar ""
execute if score @s cd3 matches 1.. run title @s[nbt={SelectedItemSlot:2}] actionbar ["",{"text":"End Gateway: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd3_seconds"},"color":"gray","bold":true}]

execute if score @s cd4 matches 0 run title @s[nbt={SelectedItemSlot:3},scores={mastery=4..}] actionbar {"text":"Void Glare","color":"light_purple","bold":true}
execute unless score @s mastery matches 4.. run title @s[nbt={SelectedItemSlot:3}] actionbar ""
execute if score @s cd4 matches 1.. run title @s[nbt={SelectedItemSlot:3}] actionbar ["",{"text":"Void Glare: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd4_seconds"},"color":"gray","bold":true}]

title @s[nbt=!{SelectedItemSlot:0},nbt=!{SelectedItemSlot:1},nbt=!{SelectedItemSlot:2},nbt=!{SelectedItemSlot:3},nbt=!{SelectedItemSlot:8}] actionbar ""

execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:0},scores={crouch=1..,cd1=0,mastery=1..}] run function power:v/v1
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:1},scores={crouch=1..,cd2=0,mastery=2..}] run function power:v/v2

execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..,crouch_time=..99}] unless score @s crouch matches 1.. run function power:v/v3
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..,crouch_time=..99,crouch=1..}] run particle portal ~ ~1 ~ .2 .4 .2 .5 10
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..,crouch_time=1,crouch=1..}] run playsound block.portal.ambient player @a ~ ~ ~ 2
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..,crouch_time=100}] run function power:v/v3_hold
execute if entity @s[nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..}] unless score @s crouch matches 1.. run scoreboard players reset @s crouch_time
execute unless entity @s[nbt={SelectedItemSlot:2},scores={cd3=0,mastery=3..}] run scoreboard players reset @s crouch_time

execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:3},scores={crouch=1..,cd4=0,mastery=4..}] run function power:v/v4

#End Gateway
execute if score @s gateway matches 1.. run scoreboard players remove @s gateway 1
execute if score @s gateway matches 1.. run particle portal ~ ~1 ~ .2 .4 .2 .5 10

execute if score @s gateway matches 159 run summon area_effect_cloud ~ ~.1 ~ {Tags:["gateway_charge","gateway_charge_spawn"],Duration:159,Radius:.5f,RadiusPerTick:.01f,Particle:{type:"dust_color_transition",from_color:[0,0,0],to_color:[1,0,1],scale:1}}
execute if score @s gateway matches 159 run summon area_effect_cloud ~ ~.1 ~ {Tags:["gateway_charge","gateway_charge_spawn"],Duration:159,Radius:.5f,RadiusPerTick:.01f,Particle:{type:"dust_color_transition",from_color:[0,0,0],to_color:[1,0,1],scale:1}}
scoreboard players operation @e[tag=gateway_charge_spawn,sort=nearest,limit=2] id = @s id
tag @e remove gateway_charge_spawn

execute if score @s gateway matches 100 run playsound block.portal.ambient player @a ~ ~ ~ 2
execute if score @s gateway matches 80 run playsound block.portal.trigger player @a ~ ~ ~ .3

execute if score @s gateway matches 0 run tag @s add gateway_tp

execute as @e[tag=gateway_charge] if score @s id = @p id if entity @s[distance=1..] run tag @p remove gateway_tp
execute as @e[tag=gateway_charge] if score @s id = @p id if entity @s[distance=1..] run scoreboard players set @p gateway 0
execute if score @s gateway matches 0 as @e[tag=gateway_charge] if score @s id = @p id if entity @s[distance=1..] run kill @s

execute if score @s gateway matches 0 if score @s[tag=gateway_tp] at_gateway matches 1 run function power:v/gateway_return
execute if score @s gateway matches 0 if score @s[tag=gateway_tp] at_gateway matches 0 run function power:v/gateway_tp
execute if score @s gateway matches 0 run tag @s remove gateway_tp
execute if score @s gateway matches 0 run tag @s remove attacking
execute if score @s gateway matches 0 run scoreboard players reset @s gateway

#Void Stare
execute if score @s stare matches ..-1 run scoreboard players add @s stare 1
execute if score @s stare matches ..-1 run particle portal ~ ~1 ~ .2 .4 .2 .5 10
execute if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @e[scores={stare_target=0..}] if score @s stare_target = @e[tag=stare_pos,sort=nearest,limit=1] id facing entity @s feet run tp @e[tag=stare_pos,sort=nearest,limit=1] ~ ~ ~ ~ ~
execute if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id run tp @p @s

execute if score @s stare matches ..-1 store result score @s random_tp run random value 1..8
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 1 run tp @s ~.05 ~ ~
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 2 run tp @s ~-.05 ~ ~
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 3 run tp @s ~ ~ ~.05
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 4 run tp @s ~ ~ ~-.05
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 5 run tp @s ~.05 ~ ~.05
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 6 run tp @s ~-.05 ~ ~-.05
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 7 run tp @s ~-.05 ~ ~.05
execute at @s if score @s stare matches ..-1 as @e[tag=stare_pos] if score @s id = @p id at @s as @a if score @s id = @e[tag=stare_pos,sort=nearest,limit=1] id if score @s random_tp matches 8 run tp @s ~.05 ~ ~-.05
execute if score @s stare matches ..-1 run scoreboard players reset @s random_tp

execute at @s if score @s stare matches -180..-1 as @e[scores={stare_target=0..}] if score @s stare_target = @p id facing entity @s feet run function power:v/stare_ray
execute at @s if score @s stare matches ..-1 as @e[scores={stare_target=0..}] if score @s stare_target = @p id if entity @s[distance=..3] as @p run function power:v/random_tp

execute if score @s stare matches ..-1 run title @s[nbt={SelectedItemSlot:3}] actionbar {"text":"Cancel","color":"light_purple","bold":true}
execute if score @s stare matches -160..-1 if entity @s[nbt={SelectedItemSlot:3},scores={crouch=1..}] run scoreboard players set @s stare 0

execute at @s if score @s stare matches ..-1 unless entity @s[nbt={Health:0f}] as @e[scores={stare_target=0..}] if score @s stare_target = @p id run tag @p add stare_active
execute if score @s stare matches ..-1 if entity @s[tag=!stare_active] run scoreboard players set @s stare 0
tag @s remove stare_active

execute at @s if score @s stare matches 0 as @e[tag=stare_pos] if score @s id = @p id run kill @s
execute at @s if score @s stare matches 0 as @e[scores={stare_target=0..}] if score @s stare_target = @p id run scoreboard players reset @s stare_target
execute if score @s stare matches 0 run tag @s remove attacking
execute if score @s stare matches 0 run scoreboard players reset @s stare

#Passive (Autododge)
execute unless score @s bow_shot matches 1.. unless score @s crossbow_shot matches 1.. unless score @s trident_shot matches 1.. run function power:v/autododge
execute if score @s bow_shot matches 1.. unless entity @e[type=arrow,distance=..4,nbt={inGround:false}] unless entity @e[type=spectral_arrow,distance=..4,nbt={inGround:false}] run scoreboard players reset @s bow_shot
execute if score @s crossbow_shot matches 1.. unless entity @e[type=arrow,distance=..4,nbt={inGround:false}] unless entity @e[type=spectral_arrow,distance=..4,nbt={inGround:false}] run scoreboard players reset @s crossbow_shot
execute if score @s trident_shot matches 1.. unless entity @e[type=trident,distance=..4,nbt={inGround:false}] run scoreboard players reset @s trident_shot