execute if score @s cd1 matches 0 run title @s[nbt={SelectedItemSlot:0},scores={mastery=1..}] actionbar {"text":"Corrupt","color":"dark_blue","bold":true}
execute unless score @s mastery matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ""
execute if score @s cd1 matches 1.. run title @s[nbt={SelectedItemSlot:0}] actionbar ["",{"text":"Corrupt: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd1_seconds"},"color":"gray","bold":true}]

execute if score @s cd2 matches 0 run title @s[nbt={SelectedItemSlot:1},scores={mastery=2..}] actionbar {"text":"Emerge","color":"dark_blue","bold":true}
execute unless score @s mastery matches 2.. run title @s[nbt={SelectedItemSlot:1}] actionbar ""
execute if score @s cd2 matches 1.. run title @s[nbt={SelectedItemSlot:1}] actionbar ["",{"text":"Emerge: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd2_seconds"},"color":"gray","bold":true}]

execute if score @s cd3 matches 0 run title @s[nbt={SelectedItemSlot:2},scores={mastery=3..}] actionbar {"text":"Sonic Shriek","color":"dark_blue","bold":true}
execute unless score @s mastery matches 3.. run title @s[nbt={SelectedItemSlot:2}] actionbar ""
execute if score @s cd3 matches 1.. run title @s[nbt={SelectedItemSlot:2}] actionbar ["",{"text":"Sonic Shriek: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd3_seconds"},"color":"gray","bold":true}]

execute if score @s cd4 matches 0 run title @s[nbt={SelectedItemSlot:3},scores={mastery=4..}] actionbar {"text":"Abyssal Onslaught","color":"dark_blue","bold":true}
execute unless score @s mastery matches 4.. run title @s[nbt={SelectedItemSlot:3}] actionbar ""
execute if score @s cd4 matches 1.. run title @s[nbt={SelectedItemSlot:3}] actionbar ["",{"text":"Abyssal Onslaught: ","color":"gray","bold":true},{"score":{"name":"@s","objective":"cd4_seconds"},"color":"gray","bold":true}]

title @s[nbt=!{SelectedItemSlot:0},nbt=!{SelectedItemSlot:1},nbt=!{SelectedItemSlot:2},nbt=!{SelectedItemSlot:3},nbt=!{SelectedItemSlot:8}] actionbar ""

execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:0},scores={crouch=1..,cd1=0,mastery=1..}] run function power:c/c1
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:1},scores={crouch=1..,cd2=0,mastery=2..}] run function power:c/c2
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:2},scores={crouch=1..,cd3=0,mastery=3..}] run function power:c/c3
execute if entity @s[tag=!attacking,nbt={SelectedItemSlot:3},scores={crouch=1..,cd4=0,mastery=4..}] run function power:c/c4

scoreboard players reset @s c
execute as @e[tag=shrieker,tag=!remove_sculk] if score @s sculk = @p id run scoreboard players add @p c 1

execute if score @s c matches 6.. as @e[tag=shrieker,tag=!remove_sculk,scores={sculk_spread=6..},sort=random,limit=1] if score @s sculk = @p id run tag @s add remove_sculk

execute as @e[tag=shrieker,scores={sculk=0..},tag=!remove_sculk,distance=100..] if score @s sculk = @p id run tag @s add remove_sculk

execute if entity @s[tag=emerge] run effect give @s resistance 1 255 true
execute if entity @s[tag=emerge] run scoreboard players add @s emerge 1

execute if score @s emerge matches 1 run summon armor_stand ~ ~ ~ {Tags:["cpos"],Silent:true,Invulnerable:true,Invisible:true,NoGravity:true}
execute if score @s emerge matches 1 run tp @e[tag=cpos,sort=nearest,limit=1] @s
execute if score @s emerge matches 1 run scoreboard players operation @e[tag=cpos,sort=nearest,limit=1] c = @s id
execute if score @s emerge matches 1.. as @e[tag=cpos] if score @s c = @p id run tp @p @s

execute at @s if score @s emerge matches 1 as @e[tag=ctp] if score @s c = @p id at @s run playsound entity.warden.dig player @a ~ ~ ~ 2
execute at @s if score @s emerge matches 1 run playsound entity.warden.dig player @a ~ ~ ~ 2
execute at @s if score @s emerge matches 1.. run particle block{block_state:"sculk"} ~ ~.1 ~ .25 .25 .25 0 10
execute at @s if score @s emerge matches 1.. as @e[tag=ctp] if score @s c = @p id at @s run particle block{block_state:"sculk"} ~ ~-1 ~ .25 0 .25 0 5
execute at @s if score @s emerge matches 1.. as @e[tag=ctp] if score @s c = @p id at @s run particle sculk_charge{roll:0} ~ ~-1 ~ .25 0 .25 0 1

execute at @s if score @s emerge matches 1..19 as @e[tag=cpos] if score @s c = @p id at @s run tp @s ~ ~-.1 ~
execute at @s if score @s emerge matches 20 as @e[tag=ctp] if score @s c = @p id at @s as @a if score @s id = @e[tag=ctp,sort=nearest,limit=1] c align xyz run tp @s ~.5 ~-2 ~.5
execute at @s if score @s emerge matches 20 as @e[tag=cpos] if score @s c = @p id run tp @s @p

execute at @s if score @s emerge matches 30..49 as @e[tag=cpos] if score @s c = @p id at @s run tp @s ~ ~.1 ~

execute at @s if score @s emerge matches 50 as @e[tag=cpos] if score @s c = @p id run kill @s
execute at @s if score @s emerge matches 50 as @e[tag=ctp] if score @s c = @p id run kill @s
execute at @s if score @s emerge matches 50 run tag @s remove attacking
execute at @s if score @s emerge matches 50 run tag @s remove emerge
execute at @s if score @s emerge matches 50 run scoreboard players reset @s emerge

execute if score @s shriek matches 1..49 run scoreboard players add @s shriek 1
execute if score @s shriek matches 1..30 unless score @s awaken matches 1.. run particle dust_color_transition{from_color:[0f,0f,0f], to_color:[0f,.8f,.8f], scale:1} ~ ~1 ~ .4 .4 .4 1 10
execute if score @s shriek matches 1..30 unless score @s awaken matches 1.. run particle warped_spore ~ ~1 ~ .2 .4 .2 1 10
execute if score @s shriek matches 40 anchored eyes run summon armor_stand ~ ~ ~ {Tags:["shriekpos"],Invulnerable:true,Invisible:true,NoGravity:true,Marker:true}
execute if score @s shriek matches 40 anchored eyes run tp @e[tag=shriekpos,sort=nearest,limit=1] ^ ^ ^ ~ ~
execute if score @s shriek matches 40 anchored eyes run scoreboard players operation @e[tag=shriekpos,sort=nearest,limit=1] id = @s id
execute if score @s shriek matches 40 run tag @s remove attacking
execute if score @s shriek matches 50 anchored eyes run playsound entity.warden.sonic_boom player @a ~ ~ ~ 2
execute if score @s shriek matches 50 run scoreboard players reset @s shriek

execute as @e[tag=shriekpos] if score @s id = @p id run function power:c/sonic_shriek

execute as @e[tag=shrieker,scores={shriek=1}] if score @s sculk = @p id run scoreboard players reset @s shriek

#Abyssal Onslaught
execute if score @s awaken matches ..-1 run scoreboard players remove @s awaken 1

execute if score @s awaken matches -2 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -2 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -40 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -40 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -80 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -80 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -100 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -100 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -120 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -120 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -130 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -130 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -140 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -140 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -150 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -150 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -160 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -160 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -170 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -170 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s awaken matches -180 run particle sonic_boom ~ ~1 ~
execute if score @s awaken matches -180 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2

execute if score @s awaken matches -180..-40 run particle warped_spore ~ ~1 ~ .2 .4 .2 1 10
execute if score @s awaken matches -180..-100 run particle dust_color_transition{from_color:[0f,0f,0f], to_color:[0f,.8f,.8f], scale:1} ~ ~1 ~ .4 .4 .4 1 10
execute if score @s awaken matches -180..-100 run particle soul_fire_flame ~ ~1 ~ .2 .4 .2 .05 2
execute if score @s awaken matches -180..-100 run playsound block.sculk_shrieker.shriek player @a ~ ~1 ~ .2

execute if score @s awaken matches -160..-140 run playsound entity.warden.roar player @a ~ ~1 ~ 2
execute if score @s awaken matches -180..-150 run particle sculk_soul ~ ~1 ~ .2 .4 .2 .5 10
execute if score @s awaken matches -180..-150 run particle soul_fire_flame ~ ~1 ~ .2 .4 .2 .5 10

execute if score @s awaken matches -160 positioned ~ ~-1 ~ if block ~ ~ ~ #sculk_replaceable run function power:c/set_awakened_sculk
execute if score @s awaken matches -160 as @e[tag=shrieker] if score @s sculk = @p id at @s run function power:c/shrieker_attack

execute if score @s awaken matches -180 run tag @s remove attacking
execute if score @s awaken matches -180 run scoreboard players set @s awaken 400

execute if score @s awaken matches 1.. run particle warped_spore ~ ~1 ~ .2 .4 .2 1 10
execute if score @s awaken matches 1.. run particle dust_color_transition{from_color:[0f,0f,0f], to_color:[0f,.8f,.8f], scale:1} ~ ~1 ~ .4 .4 .4 1 10
execute if score @s awaken matches 1.. run particle soul_fire_flame ~ ~1 ~ .2 .4 .2 .05 2
execute if score @s awaken matches 1.. run effect give @s speed 1 0 true
execute if score @s awaken matches 1.. run effect give @s strength 1 0 true
execute if score @s awaken matches 1.. run effect give @e[distance=..30] darkness 10
execute if score @s awaken matches 1.. run effect clear @s darkness

execute if score @s awaken matches 1.. if score timer sculk_spread matches 1 positioned ~ ~-1 ~ if block ~ ~ ~ #sculk_replaceable run function power:c/set_awakened_sculk

execute if score @s awaken matches 1.. run scoreboard players add @s heartbeat 1
execute unless score @s awaken matches 1.. run scoreboard players reset @s heartbeat
execute if score @s heartbeat matches 1 run playsound entity.warden.heartbeat player @a ~ ~1 ~ 2
execute if score @s heartbeat matches 10 run scoreboard players reset @s heartbeat

#Passive
execute as @e[scores={heardtime=1},distance=..20] unless score @s id = @p id as @p anchored eyes run playsound entity.warden.tendril_clicks player @s ^ ^ ^1
execute as @e[scores={heardtime=1},distance=..20] unless score @s id = @p id facing entity @s feet as @p run function power:c/sense_ray