execute as @e[tag=shrieker] if score @s sculk_spread matches ..5 run scoreboard players add @s sculk_spread 1
execute as @e[tag=shrieker] at @s positioned ~ ~ ~ if score @s sculk_spread matches 5 run function power:c/spread
execute as @e[tag=sculk] at @s if score @s sculk_spread matches ..2 if score timer sculk_spread matches 1 run function power:c/spread

execute as @e[tag=sculk] at @s if score @s sculk_spread matches ..2 if score timer sculk_spread matches 1 align xyz positioned ~.5 ~1 ~.5 run particle sculk_charge{roll:0} ~ ~ ~ .25 0 .25 0 1
execute as @e[tag=sculk] at @s if score @s sculk_spread matches ..2 if score timer sculk_spread matches 1 align xyz positioned ~.5 ~1.1 ~.5 run particle block{block_state:"sculk"} ~ ~ ~ .25 .1 .25 0 1

execute as @e[tag=awakened_sculk,scores={sculk_spread=..8}] at @s if score timer sculk_spread matches 1 run function power:c/awakened_spread
execute as @e[tag=awakened_sculk,scores={sculk_spread=..8}] at @s if score timer sculk_spread matches 1 align xyz positioned ~.5 ~1 ~.5 run particle sculk_charge{roll:0} ~ ~ ~ .25 0 .25 0 1
execute as @e[tag=awakened_sculk,scores={sculk_spread=..8}] at @s if score timer sculk_spread matches 1 align xyz positioned ~.5 ~1.1 ~.5 run particle block{block_state:"sculk"} ~ ~ ~ .25 .1 .25 0 1

execute as @e[tag=awakened_sculk] run scoreboard players add @s heartbeat 1
execute as @e[tag=awakened_sculk,scores={heartbeat=100..}] at @s run function power:c/remove_sculk
execute as @e[tag=awakened_sculk,scores={heartbeat=200..}] at @s run function power:c/force_remove_sculk

execute as @e[tag=shrieker,scores={sculk=0..},nbt={interaction:{}}] on target run tag @s add shrieker_target

# if target is the owner
execute as @e[tag=shrieker,scores={sculk=0..},nbt={interaction:{}}] if score @s sculk = @p[tag=shrieker_target] id run tag @s add remove_sculk
execute as @e[tag=shrieker,scores={sculk=0..},nbt={interaction:{}}] if score @s sculk = @p[tag=shrieker_target] id run tag @a remove shrieker_target
# else
execute as @e[tag=shrieker,scores={sculk=0..},nbt={interaction:{}}] unless score @s sculk = @p[tag=shrieker_target] id run tag @a remove shrieker_target

execute as @e[tag=shrieker,scores={sculk=0..},nbt={interaction:{}}] run data remove entity @s interaction

execute as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=7..}] at @s if score timer2 sculk_spread matches 1 run playsound block.sculk.break block @a

execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=10}] at @s as @e[tag=sculk,distance=..5] if score @s sculk = @e[tag=shrieker,sort=nearest,limit=1] sculk at @s run function power:c/force_remove_sculk
execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=10}] at @s run setblock ~ ~1 ~ air
execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=10}] at @s run particle block{block_state:"sculk"} ~ ~.5 ~ .25 .25 .25 0 50
execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=10}] at @s run particle sculk_soul ~ ~.5 ~
execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=10}] at @s run kill @s

execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=6..}] at @s run scoreboard players add @s sculk_spread 1

execute as @e[tag=shrieker,tag=remove_sculk,scores={sculk_spread=6..}] at @s as @e[tag=sculk,distance=..5] if score @s sculk = @e[tag=shrieker,sort=nearest,limit=1] sculk at @s run particle block{block_state:"sculk"} ~ ~ ~ .25 0 .25 0 1

execute if score timer2 sculk_spread matches 1 as @e[tag=shrieker,tag=remove_sculk] at @s as @e[tag=sculk,distance=..5] if score @s sculk = @e[tag=shrieker,sort=nearest,limit=1] sculk at @s run function power:c/remove_sculk

execute as @e[tag=sculk] at @s if block ~ ~ ~ air run function power:c/clean_sculk
execute as @e[tag=awakened_sculk] at @s if block ~ ~ ~ air run function power:c/clean_sculk

execute as @e[tag=bonus_dmg,nbt={HurtTime:0s}] run function power:c/shrieker_dmg

scoreboard players add timer sculk_spread 1
execute if score timer sculk_spread matches 2.. run scoreboard players reset timer sculk_spread

scoreboard players add timer2 sculk_spread 1
execute if score timer2 sculk_spread matches 4.. run scoreboard players reset timer2 sculk_spread

execute as @a if score @s awaken matches 1.. run scoreboard players remove @s awaken 1

#Remove sculk shriekers on power switch
execute as @a at @s unless score @s power matches 1 as @e[tag=shrieker] if score @s sculk = @p id run tag @s add remove_sculk