#Corruption
execute if entity @s[scores={power=1}] run tellraw @s {"text":"\nPassive: Senses nearby vibrations","color":"dark_blue","bold":true}
execute if entity @s[scores={power=1,mastery=1..}] run tellraw @s {"text":"\nCorrupt: Places a shrieker at your cursor and corrupts the surrounding area with sculk. You can have up to 5 shriekers at once. Right click shriekers to remove them","color":"dark_blue","bold":true}
execute if entity @s[scores={power=1,mastery=2..}] run tellraw @s {"text":"\nEmerge: Become invulnerable and dig to a sculk block at your cursor","color":"dark_blue","bold":true}
execute if entity @s[scores={power=1,mastery=3..}] run tellraw @s {"text":"\nSonic Shriek: Charge up a sonic blast that ignores armor and walls. If it hits a shrieker, the shrieker will emit a shriek that deals damage in a small area and gives darkness to nearby enemies","color":"dark_blue","bold":true}
execute if entity @s[scores={power=1,mastery=4..}] run tellraw @s {"text":"\nAbyssal Onslaught: Become invulnerable for a few seconds, and then transform for 20 seconds, causing all shriekers to shriek. During this transformation, you gain speed and strength, nearby enemies constantly gain darkness, and sculk grows beneath you. Emerge's cooldown is halved and can also be used on other blocks that aren't sculk","color":"dark_blue","bold":true}

#Void
#execute if entity @s[scores={power=2}] run tellraw @s {"text":"\nPassive: Automatically dodge projectiles, but take damage from water and rain (Wearing a helmet and chestplate protects from rain)","color":"light_purple","bold":true}
execute if entity @s[scores={power=2}] run tellraw @s {"text":"\nPassive: Automatically dodge arrows and tridents, but take damage from water and rain (Wearing a helmet protects from rain)","color":"light_purple","bold":true}
execute if entity @s[scores={power=2,mastery=1..}] run tellraw @s {"text":"\nTeleport: Teleport to your cursor","color":"light_purple","bold":true}
execute if entity @s[scores={power=2,mastery=2..}] run tellraw @s {"text":"\nVoid Walk: Become invulnerable and invisible for a short period of time, being able to fly and move through walls","color":"light_purple","bold":true}
execute if entity @s[scores={power=2,mastery=3..}] run tellraw @s {"text":"\nEnd Gateway: Hold to place an End Gateway at your location. Doing so will replace your current one, and will also delete your return location. End Gateways last until you change your power.\nTap to teleport to your End Gateway. Teleporting to your End Gateway sets a return location, which means using this ability again will teleport you to your previous location","color":"light_purple","bold":true}
execute if entity @s[scores={power=2,mastery=4..}] run tellraw @s {"text":"\nVoid Glare: Begin staring at the enemy at your cursor. The target will take damage whenever they look at you during this time. If the target comes too close, you teleport to a random location nearby. Use this ability again to cancel","color":"light_purple","bold":true}

#Flame
execute if entity @s[scores={power=3}] run tellraw @s {"text":"\nPassive: Fire resistance, and cooks food items that are being held","color":"red","bold":true}
execute if entity @s[scores={power=3,mastery=1..}] run tellraw @s {"text":"\nFireball: Shoot a fireball at your cursor","color":"red","bold":true}
execute if entity @s[scores={power=3,mastery=2..}] run tellraw @s {"text":"\nFlame Meteor: Launch a large fireball at your cursor","color":"red","bold":true}
execute if entity @s[scores={power=3,mastery=3..}] run tellraw @s {"text":"\nSmoke Ascension: Float in the air for a few seconds","color":"red","bold":true}
execute if entity @s[scores={power=3,mastery=4..}] run tellraw @s {"text":"\nBurning Wrath: Reset ability cooldowns and buff all other abilities for 20 seconds. Smoke Ascension will remain active until the buff wears off","color":"red","bold":true}

#Decay
execute if entity @s[scores={power=4}] run tellraw @s {"text":"\nPassive: Wither anything you hit, kills restore health","color":"dark_gray","bold":true}
execute if entity @s[scores={power=4,mastery=0..}] run tellraw @s {"text":"\nDecay Blast: Shoot a wither skull at your cursor","color":"dark_gray","bold":true}
execute if entity @s[scores={power=4,mastery=1..}] run tellraw @s {"text":"\nSiphon: Steal one heart from all withered targets (number of targets indicated by the number)","color":"dark_gray","bold":true}
execute if entity @s[scores={power=4,mastery=2..}] run tellraw @s {"text":"\nRemnants: Summon wither skeletons","color":"dark_gray","bold":true}
execute if entity @s[scores={power=4,mastery=3..}] run tellraw @s {"text":"\nWither Armor: Damage taken is reduced, using Decay Blast also shoots seekers at every withered target","color":"dark_gray","bold":true}
execute if entity @s[scores={power=4,mastery=4..}] run tellraw @s {"text":"\nReturn to Dust: Float in the air, after a few seconds all withered targets (number of targets indicated by the number) will be damaged by 3 hearts + 1 for every other target, with a maximum of 6 hearts total. Passively, if a withered target has a soul flame above their head, it means this ability can kill them","color":"dark_gray","bold":true}

#Ocean
execute if entity @s[scores={power=5}] run tellraw @s {"text":"\nPassive: Water breathing and faster swimming","color":"blue","bold":true}
execute if entity @s[scores={power=5,mastery=1..}] run tellraw @s {"text":"\nPurify/Smite: Give slowness to the target near your cursor and deal damage. Range is doubled when in water or rain / Summon a lightning bolt at the target near your cursor","color":"blue","bold":true}
execute if entity @s[scores={power=5,mastery=2..}] run tellraw @s {"text":"\nHeart of the Sea: Give water breathing and regeneration to yourself or the target at your cursor. Lasts twice as long if the target is in water or rain","color":"blue","bold":true}
execute if entity @s[scores={power=5,mastery=3..}] run tellraw @s {"text":"\nScourge/Surge: Channel a beam that deals damage to the target at your cursor / Summon a tsunami that damages and drags enemies caught in its path","color":"blue","bold":true}
execute if entity @s[scores={power=5,mastery=4..}] run tellraw @s {"text":"\nSea's Curse: Become invulnerable for a few seconds and cause a storm that lasts 20 seconds. During this time, all nearby enemies are given slowness and mining fatigue, Purify becomes Smite and Scourge becomes Surge","color":"blue","bold":true}

#tellraw @s {"text":"\n[Unlock Next Ability]","color":"blue","clickEvent": {"action":"run_command","value":"/trigger menu set 5"}}