#Purify
scoreboard players add @e[scores={purify_id=0..}] purify_tick 1

execute as @e[scores={purify_tick=0..}] at @s run particle nautilus ~ ~1 ~ 0 0 0 1 2
execute as @e[tag=!smite,scores={purify_tick=0..}] at @s run particle splash ~ ~ ~ .4 0 .4 1 10
execute as @e[tag=!smite,scores={purify_tick=40..}] at @s run particle splash ~ ~1 ~ .4 .4 .4 1 100
execute as @e[tag=!smite,scores={purify_tick=40..}] at @s run playsound entity.player.splash.high_speed player @a ~ ~ ~ 2
execute as @e[tag=!smite,scores={purify_tick=40..}] at @s as @a if score @s id = @e[scores={purify_tick=40..},sort=nearest,limit=1] purify_id run damage @e[scores={purify_tick=40..},sort=nearest,limit=1] 4 player_attack by @s

execute as @e[tag=smite,scores={purify_tick=40..}] at @s run particle flash ~ ~1 ~
execute as @e[tag=smite,scores={purify_tick=40..}] at @s run playsound item.trident.thunder player @a ~ ~ ~ 2
execute as @e[tag=smite,scores={purify_tick=40..}] at @s run summon lightning_bolt ~ ~ ~ {Tags:["smightning"]}
execute as @e[tag=smite,scores={purify_tick=40..}] at @s run tag @s remove smite

scoreboard players add @e[tag=smightning] curse_tick 1
kill @e[tag=smightning,scores={curse_tick=10..}]

scoreboard players reset @e[scores={purify_tick=40..}] purify_id
scoreboard players reset @e[scores={purify_tick=40..}] purify_tick

#Heart of the Sea
scoreboard players remove @e[scores={heal_tick=1..},tag=!in_water] heal_tick 2
scoreboard players remove @e[scores={heal_tick=1..},tag=in_water] heal_tick 1

effect give @e[scores={heal_tick=1..}] regeneration infinite 1
effect give @e[scores={heal_tick=1..}] conduit_power infinite

execute as @e[scores={heal_tick=1..}] at @s if score ascend flame_timer matches 1 run playsound block.water.ambient player @a ~ ~ ~ 2

execute as @e[scores={heal_tick=1..}] at @s as @e[tag=heal_effect] if score @s heal_id = @e[scores={heal_tick=1..},sort=nearest,limit=1] heal_id rotated as @s run tp @s ~ ~ ~ ~5 ~

execute as @e[tag=heal_effect] at @s run particle falling_water ^ ^1 ^1 .1 .1 .1 1 1
execute as @e[tag=heal_effect] at @s run particle splash ^ ^1 ^1 .1 .1 .1 1 1
execute as @e[tag=heal_effect] at @s run summon item_display ^ ^1 ^1 {Tags:["sea_heart"],item:{id:"heart_of_the_sea",Count:1},billboard:"center",transformation:{left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f],right_rotation:[0f,0f,0f,1f],scale:[.5f,.5f,.5f]}}

execute as @e[tag=heal_effect] at @s run particle falling_water ^ ^1 ^-1 .1 .1 .1 1 1
execute as @e[tag=heal_effect] at @s run particle splash ^ ^1 ^-1 .1 .1 .1 1 1
execute as @e[tag=heal_effect] at @s run summon item_display ^ ^1 ^-1 {Tags:["sea_heart"],item:{id:"heart_of_the_sea",Count:1},billboard:"center",transformation:{left_rotation:[0f,0f,0f,1f],translation:[0f,0f,0f],right_rotation:[0f,0f,0f,1f],scale:[.5f,.5f,.5f]}}

kill @e[tag=sea_heart,scores={awakened_meteor=2..}]
scoreboard players add @e[tag=sea_heart] awakened_meteor 1

execute as @e[tag=heal_effect] at @s as @e[scores={heal_tick=1..}] if score @s heal_id = @e[tag=heal_effect,sort=nearest,limit=1] heal_id run tag @e[tag=heal_effect,sort=nearest,limit=1] add alive
kill @e[tag=heal_effect,tag=!alive]
tag @e[tag=heal_effect] remove alive

effect clear @e[scores={heal_tick=..0}] regeneration
effect clear @e[scores={heal_tick=..0}] conduit_power
scoreboard players reset @e[scores={heal_tick=..0}] heal_id
scoreboard players reset @e[scores={heal_tick=..0}] heal_tick


execute unless entity @e[scores={heal_id=0..}] run scoreboard players set num heal_id 1

execute as @e[scores={heal_tick=1..}] at @s run function power:o/water_check2

scoreboard players add @e[tag=water_check2] rain_check 1

execute as @e[tag=water_check2,nbt={Fire:0s}] at @s as @e[scores={heal_tick=1..}] if score @s heal_id = @e[tag=water_check2,sort=nearest,limit=1] heal_id run tag @s add in_water
execute as @e[tag=water_check2,nbt=!{Fire:0s},scores={rain_check=2..}] at @s as @e[scores={heal_tick=1..}] if score @s heal_id = @e[tag=water_check2,sort=nearest,limit=1] heal_id run tag @s remove in_water
kill @e[tag=water_check2,scores={rain_check=2..}]
kill @e[tag=water_check2,nbt={Fire:0s}]

#Sea's Curse
scoreboard players remove @a[scores={curse_tick=1..}] curse_tick 1

execute as @a[scores={curse_tick=401..}] at @s run particle splash ~ ~ ~ .4 0 .4 1 10
execute as @a[scores={curse_tick=401..}] at @s run playsound entity.warden.heartbeat player @a ~ ~ ~ 1 .5
execute as @a[scores={curse_tick=401..}] at @s run effect give @s resistance infinite 255 true
execute as @a[scores={curse_tick=401..}] at @s run effect give @s weakness infinite 255 true
execute as @a[scores={curse_tick=401..}] at @s run effect give @s slowness infinite 255 true

execute as @a[scores={curse_tick=420}] at @s run summon item_display ~ ~ ~ {Tags:["curse_effect","curse_effect_spawn"],item:{id:"iron_ingot",components:{"custom_model_data":7}},brightness:{block:15,sky:15}}
execute as @a[scores={curse_tick=420}] at @s run scoreboard players operation @e[tag=curse_effect_spawn,sort=nearest,limit=1] id = @s id
execute as @a[scores={curse_tick=420}] at @s run tag @e remove curse_effect_spawn
execute as @a[scores={curse_tick=420}] at @s run summon lightning_bolt ~ ~-3 ~
execute as @a[scores={curse_tick=420}] at @s run particle flash ~ ~1 ~
execute as @a[scores={curse_tick=420}] at @s run playsound item.trident.thunder player @a ~ ~ ~ 2
execute as @a[scores={curse_tick=400}] at @s run effect clear @s resistance
execute as @a[scores={curse_tick=400}] at @s run effect clear @s weakness
execute as @a[scores={curse_tick=400}] at @s run effect clear @s slowness

execute as @a[scores={curse_tick=1..420}] at @s run playsound entity.breeze.idle_ground player @a ~ ~ ~ .2 .8
execute as @a[scores={curse_tick=1..450}] at @s run particle splash ~ ~1 ~ .4 .4 .4 1 10
execute as @a[scores={curse_tick=1..450}] at @s run playsound entity.player.swim player @a ~ ~ ~ .1

execute as @a[scores={curse_tick=1..420}] at @s as @e[distance=..20,tag=!cursed] unless score @s id = @p id run function power:o/curse

effect give @e[tag=cursed] slowness 1 1
effect give @e[tag=cursed] mining_fatigue 1 1

execute as @e[tag=cursed] at @s unless entity @a[scores={curse_tick=1..420},distance=..20] run tag @s remove cursed

execute as @e[tag=curse_effect] at @s as @a[scores={curse_tick=1..}] if score @s id = @e[tag=curse_effect,sort=nearest,limit=1] id run tag @e[tag=curse_effect,sort=nearest,limit=1] add alive
execute as @a[scores={curse_tick=1..}] at @s as @e[tag=curse_effect] if score @s id = @p id rotated as @s run tp @s ~ ~.5 ~ ~15 ~

execute as @e[tag=curse_effect] at @s run particle splash ^ ^-.5 ^2 0 0 0 1 20
execute as @e[tag=curse_effect] at @s run particle splash ^ ^-.5 ^-2 0 0 0 1 20

kill @e[tag=curse_effect,tag=!alive]
tag @e[tag=curse_effect] remove alive

tag @a[scores={curse_tick=400}] remove attacking

execute as @a[scores={curse_tick=1..}] run weather thunder

execute as @a[scores={curse_tick=0}] run weather clear

scoreboard players reset @a[scores={curse_tick=0}] curse_tick

#Surge

execute as @e[type=player,scores={wave_tick=1..}] at @s run particle bubble_pop ~ ~1 ~ .4 .8 .4 .5 50
scoreboard players remove @e[type=player,scores={wave_tick=1..}] wave_tick 1
scoreboard players reset @e[type=player,scores={wave_tick=0}] wave_tick

execute as @e[tag=wave,scores={wave_tick=1}] run data modify entity @s item set value {id:"iron_ingot",components:{"custom_model_data":8}}

scoreboard players add @e[tag=wave] wave_tick 1

execute as @e[tag=wave,scores={wave_tick=1..60}] at @s run tp @s ^ ^.18 ^.5
execute as @e[tag=wave,scores={wave_tick=61..100}] at @s run tp @s ^ ^ ^.5
execute as @e[tag=wave,scores={wave_tick=100..}] at @s run tp @s ^ ^-.18 ^.5

kill @e[tag=wave,scores={wave_tick=160..}]

execute as @e[tag=wave] at @s run playsound entity.player.swim player @a ~ ~ ~ 3 1.2
execute as @e[tag=wave] at @s run playsound entity.warden.heartbeat player @a ~ ~ ~ 5

execute as @e[tag=wave] at @s run particle splash ^-13 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^-10 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^-7 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^-4 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^-1 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^1 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^4 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^7 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^10 ^-10 ^8 1 1 1 1 50
execute as @e[tag=wave] at @s run particle splash ^13 ^-10 ^8 1 1 1 1 50

execute as @e[tag=wave] at @s positioned ~-5 ~-10 ~ as @e[type=!item,type=!item_frame,type=!glow_item_frame,type=!armor_stand,type=!item_display,type=!experience_orb,type=!#impact_projectiles,type=!interaction,distance=..10] unless score @s id = @e[tag=wave,sort=nearest,limit=1] id run function power:o/wave_dmg
execute as @e[tag=wave] at @s positioned ~ ~-10 ~ as @e[type=!item,type=!item_frame,type=!glow_item_frame,type=!armor_stand,type=!item_display,type=!experience_orb,type=!#impact_projectiles,type=!interaction,distance=..10] unless score @s id = @e[tag=wave,sort=nearest,limit=1] id run function power:o/wave_dmg
execute as @e[tag=wave] at @s positioned ~5 ~-10 ~ as @e[type=!item,type=!item_frame,type=!glow_item_frame,type=!armor_stand,type=!item_display,type=!experience_orb,type=!#impact_projectiles,type=!interaction,distance=..10] unless score @s id = @e[tag=wave,sort=nearest,limit=1] id run function power:o/wave_dmg

#Passive
execute as @a[scores={power=5}] at @s run function power:o/water_check

scoreboard players add @e[tag=water_check] rain_check 1

execute as @e[tag=water_check,nbt={Fire:0s}] at @s as @a[scores={power=5}] if score @s id = @e[tag=water_check,sort=nearest,limit=1] id run tag @s add in_water
execute as @e[tag=water_check,nbt=!{Fire:0s},scores={rain_check=2..}] at @s as @a[scores={power=5}] if score @s id = @e[tag=water_check,sort=nearest,limit=1] id run tag @s remove in_water
kill @e[tag=water_check,scores={rain_check=2..}]
kill @e[tag=water_check,nbt={Fire:0s}]

effect give @a[scores={power=5},tag=in_water] conduit_power 1 0 true
effect give @a[scores={power=5},tag=in_water] dolphins_grace 1 0 true